#include<bits/stdc++.h>
using namespace std;

int s, k[2000], n, ans;

void f(int cs, int kart){
    if(kart >= 5) return;
    if(cs == 0){
        if(ans > kart) ans = kart;
        return;
    }
    if(cs < 0) return;
    for(int i = 0; i < n; i++){
        f(cs-k[i], kart+1);
    }
}


int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> s >> n;
    for(int i = 0; i < n; i++){
        cin >> k[i];
    }
    ans = 2001;
    f(s, 0);

    cout << ans;
    return 0;
}
